import  re
import string

def c_ip_netmask(ip):
    if re.match("^(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])\\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])\\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])/((3[0-2])|([0-2]\\d)|[1-9])",ip)==None:
        return None
    else: return 'OK'

def c_port(port): #Ports with the format 'xxxx[:xxxx]'
	try:
		h = string.split(port,':')
		if len(h) == 1:
			if string.atoi(h[0])>0 and string.atoi(h[0])<65536:
				return 'OK'
			else: return None
		else: 
			if len(h) == 2:
				if string.atoi(h[0])>0 and string.atoi(h[0])<65536:
					if string.atoi(h[1])>0 and string.atoi(h[1])<65536 and string.atoi(h[1])>string.atoi(h[0]):
						return 'OK'
					else: return None
				else: return None
			else: return None
	except: return None

def c_port2(port): #Ports with the format 'xxxx[-xxxx]'
	try:
		h = string.split(port,'-')
		if len(h) == 1:
			if string.atoi(h[0])>0 and string.atoi(h[0])<65536:
				return 'OK'
			else: return None
		else: 
			if len(h) == 2:
				if string.atoi(h[0])>0 and string.atoi(h[0])<65536:
					if string.atoi(h[1])>0 and string.atoi(h[1])<65536 and string.atoi(h[1])>string.atoi(h[0]):
						return 'OK'
					else: return None
				else: return None
			else: return None
	except: return None

def c_alias(data,valid_alias): 
	for i in range(len(valid_alias)):
		if valid_alias[i] == data: 		
			return 'OK'
	return None