import gtk
import error_dialog
DEBUG = 0

def show(gdata):
	gdata.wtree.get_widget('dlg_iface').show()
	gdata.wtree.get_widget('cls_iface').clear()
	gdata.wtree.get_widget('txt_iface_name').set_text('')
	gdata.wtree.get_widget('txt_iface_comment').set_text('')
	iface_data(gdata)
	for x in gdata.iface.keys():
		gdata.iface_bk[x] = gdata.iface[x]

def iface_data(gdata):
	c=gdata.wtree.get_widget('cls_iface')
	c.clear()
	if DEBUG == 1: print 'Ifaces:',gdata.iface
	ifc = gdata.iface
	for i in ifc.keys():
		c.append((i,ifc[i]['comment']))

def btn_add_iface_clicked(self,gdata):
	error_text=[]
	iface_name = gdata.wtree.get_widget('txt_iface_name').get_text()
	iface_comment = gdata.wtree.get_widget('txt_iface_comment').get_text()
	if iface_name != '':
		if gdata.iface.has_key(iface_name)==0:
			gdata.add_iface(iface_name,iface_comment)
			gdata.wtree.get_widget('txt_iface_name').set_text('')
			gdata.wtree.get_widget('txt_iface_comment').set_text('')
			iface_data(gdata)
		else: error_text.append('Interface already exists!')
	else: error_text.append('No interface specified!')
	if len(error_text)>0:
		error_dialog.show(gdata,error_text)
		

def btn_del_iface_clicked(self,gdata):
	c=gdata.wtree.get_widget('cls_iface')
	for i in c.selection:
		iface = c.get_text(i,0)
		gdata.del_iface(iface)
		iface_data(gdata)

def btn_iface_ok_clicked(self,gdata):
	gdata.wtree.get_widget('dlg_iface').hide()

def btn_iface_cancel_clicked(self,gdata):
	gdata.wtree.get_widget('dlg_iface').hide()
	gdata.iface = gdata.iface_bk
	for x in gdata.iface_bk.keys():
		gdata.iface[x] = gdata.iface_bk[x]
