import gtk
import error_dialog
from firewall import check
DEBUG = 0

def show(gdata):
	gdata.wtree.get_widget('dlg_ip').show()
	gdata.wtree.get_widget('cls_ip').clear()
	gdata.wtree.get_widget('txt_ip_alias').set_text('')
	gdata.wtree.get_widget('txt_ip_address').set_text('')
	gdata.wtree.get_widget('txt_ip_comment').set_text('')
	ip_data(gdata)
	for x in gdata.ip.keys():
		gdata.ip_bk[x] = gdata.ip[x]

def ip_data(gdata):
	c=gdata.wtree.get_widget('cls_ip')
	c.clear()
	if DEBUG == 1: print 'IPs:',gdata.ip
	ip = gdata.ip
	for i in ip.keys():
		c.append((i,ip[i]['address'],ip[i]['comment']))

def btn_add_ip_clicked(self,gdata):
	error_text=[]
	ip_name = gdata.wtree.get_widget('txt_ip_alias').get_text()
	ip_address = gdata.wtree.get_widget('txt_ip_address').get_text()
	ip_comment = gdata.wtree.get_widget('txt_ip_comment').get_text()
	if ip_name != '':
		if gdata.ip.has_key(ip_name)==0:
			if check.c_ip_netmask(ip_address)=='OK':
				gdata.add_ip(ip_name,ip_address,ip_comment)
				gdata.wtree.get_widget('txt_ip_alias').set_text('')
				gdata.wtree.get_widget('txt_ip_address').set_text('')
				gdata.wtree.get_widget('txt_ip_comment').set_text('')
				ip_data(gdata)
			else: error_text.append('Invalid IP address!')
		else: error_text.append('IP alias already exists!')
	else: error_text.append('No IP alias specified!')
	if len(error_text)>0: error_dialog.show(gdata,error_text)

def btn_del_ip_clicked(self,gdata):
	c=gdata.wtree.get_widget('cls_ip')
	for i in c.selection:
		ip = c.get_text(i,0)
		gdata.del_ip(ip)
		ip_data(gdata)

def btn_ip_ok_clicked(self,gdata):
	gdata.wtree.get_widget('dlg_ip').hide()

def btn_ip_cancel_clicked(self,gdata):
	gdata.wtree.get_widget('dlg_ip').hide()
	gdata.ip = gdata.ip_bk
	for x in gdata.ip_bk.keys():
		gdata.ip[x] = gdata.ip_bk[x]
