import gtk
import error_dialog
from firewall import check
DEBUG = 0

def show(gdata):
	gdata.wtree.get_widget('dlg_port').show()
	port_data(gdata)
	for x in gdata.port.keys():
		gdata.port_bk[x] = gdata.port[x]

def port_data(gdata):
	c=gdata.wtree.get_widget('cls_port')
	c.clear()
	if DEBUG == 1: print 'Ports:',gdata.port
	port = gdata.port
	for i in port.keys():
		if port[i]['end'] == None: p_end =''
		else: p_end = port[i]['end']
		c.append((i,port[i]['begin'],p_end,port[i]['comment']))

def btn_add_port_clicked(self,gdata):
	error_text=[]
	port_name = gdata.wtree.get_widget('txt_port_alias').get_text()
	port_comment = gdata.wtree.get_widget('txt_port_comment').get_text()
	port_begin = gdata.wtree.get_widget('txt_port_begin').get_text()
	port_end = gdata.wtree.get_widget('txt_port_end').get_text()
	if port_name != '':
		if gdata.port.has_key(port_name)==0:
			if DEBUG == 1: print port_begin,':',port_end
			if port_end!='':hlp = port_begin+':'+port_end 
			else: hlp = port_begin
			if check.c_port(hlp)=='OK':			
				if port_end=='': port_end = None
				gdata.add_port(port_name,port_begin,port_end,port_comment)
				gdata.wtree.get_widget('txt_port_alias').set_text('')
				gdata.wtree.get_widget('txt_port_comment').set_text('')
				gdata.wtree.get_widget('txt_port_begin').set_text('')
				gdata.wtree.get_widget('txt_port_end').set_text('')
				port_data(gdata)
			else: error_text.append('Port format invalid!')
		else: error_text.append('Port alias already exists!')
	else: error_text.append('No port alias specified!')
	if len(error_text)>0: error_dialog.show(gdata,error_text)

def btn_del_port_clicked(self,gdata):
	c=gdata.wtree.get_widget('cls_port')
	for i in c.selection:
		port = c.get_text(i,0)
		gdata.del_port(port)
		port_data(gdata)

def btn_port_ok_clicked(self,gdata):
	gdata.wtree.get_widget('dlg_port').hide()

def btn_port_cancel_clicked(self,gdata):
	gdata.wtree.get_widget('dlg_port').hide()
	for x in gdata.port_bk.keys():
		gdata.port[x] = gdata.port_bk[x]