#utility functions for the gui
import gtk
DEBUG = 0

def option_disable(gdata,widget):
	try:
	        py_frm = gdata.wtree.get_widget(widget)
	        py_frm.set_sensitive(gtk.FALSE)
	except:
		if DEBUG == 1: print "warning: could not disable widget (",widget,")"

def option_enable(gdata,widget):
	try:
	       py_frm = gdata.wtree.get_widget(widget)
 	       py_frm.set_sensitive(gtk.TRUE)
	except:
		print "warning: could not enable widget (",widget,")"
#---combo box init--------------------
def add_predefined_data(gdata,combo,data): #widget as Combo #data as dictionary
	widget = combo
	for i in range(len(data)):	
		item = gtk.GtkListItem(data[i])
		item.show()
		widget.list.add(item) #add new elements
def add_list_data(gdata,widget,list):
	combo = gdata.wtree.get_widget(widget)
	for i in list:
		item = gtk.GtkListItem(i)
		item.show()
		combo.list.add(item)
def init_combo(gdata,widget,data):
	combo = gdata.wtree.get_widget(widget)
	combo.list.clear_items(0,-1) #delete all old elements
	add_predefined_data(gdata,combo,data)
def init_chain_combo(gdata,widget,data,list):
	init_combo(gdata,widget,data)
	add_list_data(gdata,widget,list)

def init_combo_add_empty(gdata,widget,data):
	combo = gdata.wtree.get_widget(widget)
	combo.list.clear_items(0,-1) #delete all old elements
	item = gtk.GtkListItem('')
	item.show()
	combo.list.add(item)
	add_predefined_data(gdata,combo,data)

	
#-------------------------------------
def disable_tgt_ext(gdata):
	targets = ("tgt_log","tgt_mark","tgt_reject","tgt_tos","tgt_snat","tgt_dnat","tgt_redirect","tgt_masquerade")
	for i in targets:
		try:
			option_disable(gdata,i)
		except:
			print "Exception in disable_tgt_ext target:",i
def activate_tgt_ext(gdata,active_tgt):
	option_enable(gdata,active_tgt)
#-OBSOLETE------------------------------------
def switch_to_txt(gdata,txt_widget,omn_widget):
        py_txt = gdata.wtree.get_widget(txt_widget)
	py_omn = gdata.wtree.get_widget(omn_widget)
	py_txt.set_editable(gtk.TRUE)
        py_txt.set_sensitive(gtk.TRUE)
	py_omn.set_sensitive(gtk.FALSE)

def switch_to_omn(gdata,txt_widget,omn_widget):
        py_txt = gdata.wtree.get_widget(txt_widget)
	py_omn = gdata.wtree.get_widget(omn_widget)
	py_txt.set_editable(gtk.FALSE)
        py_txt.set_sensitive(gtk.FALSE)
	py_omn.set_sensitive(gtk.TRUE)