import gtk
import shelve
import string

import main_window
import error_dialog
from firewall import scriptgen
DEBUG = 0

def ok_button1_clicked(self,gdata):
	if DEBUG == 1: print 'ok button clicked'
	fs = gdata.wtree.get_widget('dlg_file_sel')
	filename = fs.get_filename()
	if DEBUG == 1: print 'filename:',filename
	if gdata.fsel_mode == 'save_as':
		fn = string.split(filename,'/')
		if fn[len(fn)-1] !='':
			dbase = shelve.open(filename)
			dbase['tables'] = gdata.tables
			dbase['chains'] = gdata.chains
			dbase['rules'] = gdata.rules
			dbase['ip'] = gdata.ip
			dbase['iface'] = gdata.iface
			dbase['port'] = gdata.port
			dbase['user'] = gdata.user
			#print 'DATA from File:'
			#for i in dbase.keys():
			#	print '-----<'+i+':>',dbase[i]
			#dbase.close()
			fs.hide()
		else:
			error_dialog.show(gdata,['No filename specified!'])
	if gdata.fsel_mode == 'load':
		fn = string.split(filename,'/')
		if fn[len(fn)-1] !='':
			dbase = shelve.open(filename)
			gdata.rules = dbase['rules']
			gdata.ip = dbase['ip']
			gdata.iface = dbase['iface']
			gdata.port = dbase['port']
			gdata.user = dbase['user']
			dbase.close()
			fs.hide()
			main_window.init_window(gdata)
		else:
			error_dialog.show(gdata,['No filename specified!'])
	if gdata.fsel_mode == 'load':
		fn = string.split(filename,'/')
		if fn[len(fn)-1] !='':
			dbase = shelve.open(filename)
			gdata.rules = dbase['rules']
			gdata.ip = dbase['ip']
			gdata.iface = dbase['iface']
			gdata.port = dbase['port']
			gdata.user = dbase['user']
			dbase.close()
			fs.hide()
			main_window.init_window(gdata)
		else:
			error_dialog.show(gdata,['No filename specified!'])
	if gdata.fsel_mode == 'script':
		fn = string.split(filename,'/')
		if fn[len(fn)-1] !='':
			mydata = {}
			mydata['rules'] = gdata.rules
			mydata['ip'] = gdata.ip
			mydata['iface'] = gdata.iface
			mydata['port'] = gdata.port
			mydata['user'] = gdata.user
			scriptgen.generate(mydata,None,filename)
			fs.hide()
			main_window.init_window(gdata)
		else:
			error_dialog.show(gdata,['No filename specified!'])

def cancel_button1_clicked(self,gdata):
	if DEBUG == 1: print 'cancel button clicked'
	gdata.wtree.get_widget('dlg_file_sel').hide()