#!/usr/bin/env python
import sys
if sys.version[:3] == '1.4':
	import ni
from gtk import *
import sys
import GtkExtra
import libglade
from firewall import data
from firewall.gui import add_rule_dialog
ard = add_rule_dialog
from firewall.gui import add_iface_dialog
aid = add_iface_dialog
from firewall.gui import add_port_dialog
apd = add_port_dialog
from firewall.gui import add_ip_dialog
aipd = add_ip_dialog
from firewall.gui import error_dialog
ed = error_dialog
from firewall.gui import file_selection_dialog
f_sel = file_selection_dialog
from firewall.gui import main_window
m_win = main_window

def debug_message(self,text):
        print text

if len(sys.argv) > 1:
	fname = sys.argv[1]
else:
	fname = 'fwat.glade'

# create widget tree ...
wtree = libglade.GladeXML(fname)  #build gui from glade-file

gdata = data.gui_data(wtree) #Create Data Class
#data.test_data(gdata) #Initialize with Test-Data
def myquit(self):
	mainquit()
	sys.exit()
#signal connections
wtree.signal_connect('on_mnu_exit_activate',myquit)
wtree.signal_connect('on_wnd_fwat_destroy',myquit)
#Signals for file selection dialog---------------------------------------------------
wtree.signal_connect('on_cancel_button1_clicked',f_sel.cancel_button1_clicked,gdata)
wtree.signal_connect('on_ok_button1_clicked',f_sel.ok_button1_clicked,gdata)
#signals for main window-------------------------------------------------------------
##menu
wtree.signal_connect('on_mnu_new_activate',m_win.mnu_new_activate,gdata)
wtree.signal_connect('on_mnu_load_activate',m_win.mnu_load_activate,gdata)
wtree.signal_connect('on_mnu_save_as_activate',m_win.mnu_save_as_activate,gdata)
wtree.signal_connect('on_mnu_create_script_activate',m_win.mnu_create_script_activate,gdata)
wtree.signal_connect('on_mnu_add_ip_activate',m_win.mnu_add_ip_activate,gdata)
wtree.signal_connect('on_mnu_add_port_alias_activate',m_win.mnu_add_port_alias_activate,gdata)
wtree.signal_connect('on_mnu_add_interface_activate',m_win.mnu_add_interface_activate,gdata)
##other
wtree.signal_connect('on_txt_table1_changed',m_win.txt_table1_changed,gdata)
wtree.signal_connect('on_txt_table2_changed',m_win.txt_table2_changed,gdata)
wtree.signal_connect('on_txt_chain1_changed',m_win.txt_chain1_changed,gdata)
wtree.signal_connect('on_txt_chain2_changed',m_win.txt_chain2_changed,gdata)
wtree.signal_connect('on_btn_add1_clicked',m_win.btn_add1_clicked,gdata)
wtree.signal_connect('on_btn_add2_clicked',m_win.btn_add2_clicked,gdata)
wtree.signal_connect('on_btn_del1_clicked',m_win.btn_del1_clicked,gdata)
wtree.signal_connect('on_btn_del2_clicked',m_win.btn_del2_clicked,gdata)
wtree.signal_connect('on_btn_edit1_clicked',m_win.btn_edit1_clicked,gdata)
wtree.signal_connect('on_btn_edit2_clicked',m_win.btn_edit2_clicked,gdata)
wtree.signal_connect('on_btn_up1_clicked',m_win.btn_up1_clicked,gdata)
wtree.signal_connect('on_btn_up2_clicked',m_win.btn_up2_clicked,gdata)
wtree.signal_connect('on_btn_down1_clicked',m_win.btn_down1_clicked,gdata)
wtree.signal_connect('on_btn_down2_clicked',m_win.btn_down2_clicked,gdata)
wtree.signal_connect('on_wnd_fwat_check_resize',m_win.window_resized,gdata)
#signals for error dialog-----------------------------------------------------------
wtree.signal_connect('on_btn_error_ok_clicked',ed.hide,gdata)
wtree.signal_connect('on_dlg_error_destroy',ed.hide,gdata)
#signals for port dialog------------------------------------------------------------
wtree.signal_connect('on_btn_add_port_clicked',apd.btn_add_port_clicked,gdata)
wtree.signal_connect('on_btn_del_port_clicked',apd.btn_del_port_clicked,gdata)
wtree.signal_connect('on_btn_port_ok_clicked',apd.btn_port_ok_clicked,gdata)
wtree.signal_connect('on_btn_port_cancel_clicked',apd.btn_port_cancel_clicked,gdata)
wtree.signal_connect('on_dlg_port_destroy',apd.btn_port_cancel_clicked,gdata)
#signals for iface dialog-----------------------------------------------------------
wtree.signal_connect('on_btn_add_iface_clicked',aid.btn_add_iface_clicked,gdata)
wtree.signal_connect('on_btn_del_iface_clicked',aid.btn_del_iface_clicked,gdata)
wtree.signal_connect('on_btn_iface_ok_clicked',aid.btn_iface_ok_clicked,gdata)
wtree.signal_connect('on_btn_iface_cancel_clicked',aid.btn_iface_cancel_clicked,gdata)
wtree.signal_connect('on_dlg_iface_destroy',aid.btn_iface_cancel_clicked,gdata)
#signals for ip dialog--------------------------------------------------------------
wtree.signal_connect('on_btn_add_ip_clicked',aipd.btn_add_ip_clicked,gdata)
wtree.signal_connect('on_btn_del_ip_clicked',aipd.btn_del_ip_clicked,gdata)
wtree.signal_connect('on_btn_ip_ok_clicked',aipd.btn_ip_ok_clicked,gdata)
wtree.signal_connect('on_btn_ip_cancel_clicked',aipd.btn_ip_cancel_clicked,gdata)
wtree.signal_connect('on_dlg_ip_destroy',aipd.btn_ip_cancel_clicked,gdata)
#signals for rule dialog------------------------------------------------------------
wtree.signal_connect('on_dlg_rule_destroy',ard.cancel,gdata)
wtree.signal_connect('on_btn_cancel_clicked',ard.cancel,gdata)
wtree.signal_connect('on_btn_ok_clicked',ard.ok,gdata)
#target
wtree.signal_connect('on_txt_target_changed',ard.txt_target_changed,gdata)
#protocol
wtree.signal_connect('on_rbt_protocol_all_clicked',ard.rbt_protocol_all_clicked,gdata)
wtree.signal_connect('on_rbt_protocol_tcp_clicked',ard.rbt_protocol_tcp_clicked,gdata)
wtree.signal_connect('on_rbt_protocol_udp_clicked',ard.rbt_protocol_udp_clicked,gdata)
wtree.signal_connect('on_rbt_protocol_icmp_clicked',ard.rbt_protocol_icmp_clicked,gdata)
#signal for syn
wtree.signal_connect('on_chk_use_syn_toggled',ard.chk_use_syn_toggled,gdata)
#signal for tcp option
wtree.signal_connect('on_chk_use_tcp_option_toggled',ard.chk_use_tcp_option_toggled,gdata)
#signal for fragment
wtree.signal_connect('on_chk_use_fragment_toggled',ard.chk_use_fragment_toggled,gdata)
#signal for match limit
wtree.signal_connect('on_chk_limit_enable_toggled',ard.chk_limit_enable_toggled,gdata)
#signal for match mark
wtree.signal_connect('on_chk_mark_enable_toggled',ard.chk_mark_enable_toggled,gdata)
#signal for match state
wtree.signal_connect('on_chk_state_enable_toggled',ard.chk_state_enable_toggled,gdata)
#signal for match tos
wtree.signal_connect('on_chk_tos_enable_toggled',ard.chk_tos_enable_toggled,gdata)
#signals for loging
wtree.signal_connect('on_chk_log_level_toggled',ard.chk_log_level_toggled,gdata)
wtree.signal_connect('on_chk_log_prefix_toggled',ard.chk_log_prefix_toggled,gdata)
#--------------------------------------------------------

#lets get it on *g*

m_win.init_window(gdata)

mainloop()

